searchData={"items":[{"type":"module","title":"PhoenixIslands","doc":"Documentation for `PhoenixIslands`.","ref":"PhoenixIslands.html"},{"type":"function","title":"PhoenixIslands.island/1","doc":"","ref":"PhoenixIslands.html#island/1"},{"type":"function","title":"Attributes - PhoenixIslands.island/1","doc":"* `id` (`:string`)\n* `type` (`:atom`) - Defaults to `:data`.\n* `component` (`:string`) - Defaults to `nil`.\n* `data` (`:map`) - Defaults to `nil`.\n* `global_store_key` (`:string`) - Defaults to `nil`.\n* `live_data` (`:boolean`) - Defaults to `false`.","ref":"PhoenixIslands.html#island/1-attributes"},{"type":"function","title":"Slots - PhoenixIslands.island/1","doc":"* `inner_block`","ref":"PhoenixIslands.html#island/1-slots"},{"type":"module","title":"PhoenixIslands.LiveData","doc":"","ref":"PhoenixIslands.LiveData.html"},{"type":"function","title":"PhoenixIslands.LiveData.render/1","doc":"","ref":"PhoenixIslands.LiveData.html#render/1"},{"type":"function","title":"Attributes - PhoenixIslands.LiveData.render/1","doc":"* `data` (`:any`)","ref":"PhoenixIslands.LiveData.html#render/1-attributes"},{"type":"extras","title":"Phoenix Islands","doc":"# Phoenix Islands\n\n**Phoenix Islands** is a library for creating islands of various frontend frameworks in Phoenix LiveView.\n\nYou can see a demo at [deployed example](https://phoenix-islands-example.fly.dev/) and look at [its code on Github](https://github.com/phoenix-islands/phoenix-islands-js/tree/main/example)","ref":"readme.html"},{"type":"extras","title":"Features - Phoenix Islands","doc":"- **Live Islands**: We can enjoy huge front-end ecosystem without losing _Liveliness_. Only React is supported for now, but we can go as far as all framework that [nanostore](https://github.com/nanostores/nanostores) supports in the near future.\n- **Stream support**: That means no more giant JSON eating up server memory.\n- **LiveView children passing (Experimental)**: LiveView inside React inside Live-View.","ref":"readme.html#features"},{"type":"extras","title":"Installation - Phoenix Islands","doc":"The package can be installed by adding `phoenix_islands` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_islands, \"~> 0.2.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Phoenix Islands","doc":"First you need to add `import PhoenixIslands` to your views:\n\n```elixir\ndefmodule ExampleWeb.IslandsLive do\n  use ExampleWeb, :live_view\n\n  # add this\n  import PhoenixIslands\n\n  def mount(_params, _session, socket) do\n    {:ok, assign(socket, :counter, 1)}\n  end\n\n  def handle_event(\"update_counter\", %{\"counter\" => counter}, socket) do\n    {:noreply,\n     assign(\n       socket,\n       :counter,\n       if(is_binary(counter), do: String.to_integer(counter), else: counter)\n     )}\n  end\nend\n```\n\nAnd then you can pick an frontend framework of your liking, say...","ref":"readme.html#usage"},{"type":"extras","title":"React - Phoenix Islands","doc":"Then you can integrate React by following [this instruction](`e:phoenix_islands:react.md`) and start rendering:\n\n```heex\n \n   \n     \n      Live View React Island\n     \n    <.island id=\"1\" type={:react} component=\"ReactCounter\" data={%{\"counter\" => @counter}}>\n       \n         Server State: <%= @counter %> \n         \n          LiveView -1\n         \n       \n    </.island>\n   \n \n```","ref":"readme.html#react"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.2.2](https://github.com/phoenix-islands/phoenix_islands/compare/v0.2.1...v0.2.2) (2024-01-16)\n\n\n\n\n#","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* attr live -> live_data\n\n## [v0.2.1](https://github.com/phoenix-islands/phoenix_islands/compare/v0.2.0...v0.2.1) (2024-01-16)\n\n\n\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* should not use live_component by default\n\n## [v0.2.0](https://github.com/phoenix-islands/phoenix_islands/compare/v0.1.3...v0.2.0) (2024-01-16)\n\n\n\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features: - Change Log","doc":"* use LiveComponent for data\n\n## [v0.1.3](https://github.com/phoenix-islands/phoenix_islands/compare/v0.1.2...v0.1.3) (2024-01-16)\n\n\n\n\n## [v0.1.2](https://github.com/phoenix-islands/phoenix_islands/compare/v0.1.2...v0.1.2) (2024-01-16)\n\n\n\n\n#","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* readme","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"React Integration","doc":"# React Integration\n\nFollow instruction at [@phoenix-islands/react](https://www.npmjs.com/package/@phoenix-islands/react)","ref":"react.html"}],"content_type":"text/markdown"}